'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /**
                                                                                                                                                                                                                              * Create SuitCSS components
                                                                                                                                                                                                                              *
                                                                                                                                                                                                                              * Generates className based on component name,
                                                                                                                                                                                                                              * modifier, utility (u), and state-classes (is)
                                                                                                                                                                                                                              *
                                                                                                                                                                                                                              * Default html element is div, but can be changed
                                                                                                                                                                                                                              * i.e <table> or <form>
                                                                                                                                                                                                                              *
                                                                                                                                                                                                                              */

exports.default = function (props) {
  var component = props.component,
      children = props.children,
      _props$modifier = props.modifier,
      modifier = _props$modifier === undefined ? '' : _props$modifier,
      _props$u = props.u,
      u = _props$u === undefined ? '' : _props$u,
      _props$is = props.is,
      is = _props$is === undefined ? '' : _props$is,
      _props$Element = props.Element,
      Element = _props$Element === undefined ? 'div' : _props$Element,
      other = _objectWithoutProperties(props, ['component', 'children', 'modifier', 'u', 'is', 'Element']);

  var classNames = [component];

  if (modifier) {
    modifier.split(' ').forEach(function (m) {
      classNames.push(component + '--' + m);
    });
  }
  if (u) {
    u.split(' ').forEach(function (ut) {
      classNames.push('u-' + ut);
    });
  }
  if (is) {
    is.split(' ').forEach(function (state) {
      classNames.push('is-' + state);
    });
  }

  return _react2.default.createElement(
    Element,
    _extends({}, other, { className: classNames.join(' ') }),
    children
  );
};